<script setup>
import { onMounted } from 'vue';
import { useRoute } from 'vue-router';
import { queryTransactionsUrl } from '../lib/CoinfolioAPI';
import { reactive } from 'vue';
import { useLiveQuotesStore } from '../stores/liveQuotes';
import { numberFormat, moneyFormat } from '../lib/NumberFormatter';

const DetailsHeading = { props: [ "title" ], template: `<span class="text-secondary" style="font-size: 0.8em">{{ title }}</span>` };


let route = useRoute();
let state = reactive({
    transactionsLoaded: false,
    transactions: [],
    collapseState: {}
});

let liveQuotesStore = useLiveQuotesStore();

onMounted(async () => {
    const payload =  {
        coinfolioId: route.params.coinfolioId,
        ownerToken: route.params.ownerToken,
    };

    const res = await fetch(queryTransactionsUrl, {
        method: "POST",
        body: JSON.stringify(payload),
        headers: {
            "Content-Type": "application/json",
        }
    });

    if(res.status !== 200) {
        alert("failed to retrieve transactions");
        return;
    }

    let transactions = await res.json();
    const filterCurrency = route.params.currency;

    transactions = transactions.filter(tx => tx.pair.baseCurrency.tickerSymbol == filterCurrency);
    transactions = transactions.sort((a, b) => {
        if(a.momentOfTransaction < b.momentOfTransaction) {
            return 1;
        }

        if(a.momentOfTransaction > b.momentOfTransaction) {
            return -1;
        }

        return 0;
    })

    console.log("Transactions loaded", transactions);

    transactions.forEach(tx => {
        const baseCurrency = tx.pair.baseCurrency;

        const currentUnitPrice = liveQuotesStore.byCurrency(baseCurrency.tickerSymbol);
        const originalValue = tx.amount * tx.unitPrice;
        const currentValue = tx.amount * currentUnitPrice;
        const isProfit = currentValue >= originalValue;

        const valueChange = currentValue - originalValue;
        let percentChange = currentValue / originalValue;
        if(!isProfit) {
            percentChange = (currentValue / originalValue  - 1) * 100;
        }
        


        state.transactions.push({
            cftxid: tx.coinFolioTransactionId,
            direction: tx.direction,
            pair: tx.pair,
            quoteCurrencySymbol: tx.pair.quoteCurrency.tickerSymbol,
            baseCurrencySymbol: tx.pair.baseCurrency.tickerSymbol,
            amount: numberFormat(tx.amount),
            fee: moneyFormat(tx.fee),
            momentOfTransaction: tx.momentOfTransaction,
            exchange: tx.exchange,
            notes: tx.notes,
            unitPrice: moneyFormat(tx.unitPrice),
            currentUnitPrice: moneyFormat(currentUnitPrice),
            originalValue: moneyFormat(originalValue),
            currentValue: moneyFormat(currentValue),
            valueChange: (valueChange > 0 ? '+' : '') + moneyFormat(valueChange),
            percentChange: (isProfit ? '+' : '') + numberFormat(percentChange),
            isProfit,
        })

        state.collapseState[tx.coinFolioTransactionId] = false;
    });



    state.transactionsLoaded = true;
});

function toggleCollapse(cftxid) {
    const targetSelector = '#collapse-' + cftxid;
    const targetElement = document.querySelector(targetSelector);
    bootstrap.Collapse.getOrCreateInstance(targetElement).toggle();

    state.collapseState[cftxid] = !state.collapseState[cftxid];
}
</script>

<template>
    <div class="col-8">
        <div v-if="state.transactionsLoaded" v-for="tx in state.transactions" class="card mb-3" data-bs-toggle="collapses" :data-bs-target="'#collapse-' + tx.cftxid">
            <div class="card-header">
                <div class="row">
                    <div class="col-10">
                        {{ tx.direction == "BUY" ? "Bought" : "Sold" }} {{ tx.amount }} {{ tx.baseCurrencySymbol }}
                        for {{ tx.originalValue }} {{ tx.quoteCurrencySymbol }}<br/>
                    </div>
                    <div class="col-2 text-end">
                        <i v-if="!state.collapseState[tx.cftxid]" v-on:click="toggleCollapse(tx.cftxid)" title="Show Details" class="bi bi-chevron-double-down"></i>
                        <i v-if="state.collapseState[tx.cftxid]" v-on:click="toggleCollapse(tx.cftxid)" title="Hide Details" class="bi bi-chevron-double-up"></i>
                    </div>
                </div>
            </div>

            <div class="card-body">
                <div class="row">
                    <div class="col-6">
                        <DetailsHeading title="Current Value:" /><br />
                        {{ tx.currentValue }} {{ tx.quoteCurrencySymbol }}
                    </div>
                    <div class="col-6 text-end">
                        <DetailsHeading title="Change:" /> <br />
                        <span :class="{ 'text-success': tx.isProfit, 'text-danger': !tx.isProfit }">{{ tx.valueChange }} {{
                            tx.quoteCurrencySymbol }}<br />({{ tx.percentChange }}%)</span>
                    </div>
                </div>
                <div class="collapse" :id="'collapse-' + tx.cftxid">
                    <div class="row">
                        <div class="col-6">
                            <DetailsHeading title="Moment of Transaction:" /><br />
                            {{ tx.momentOfTransaction }}
                        </div>
                        <div class="col-6 text-end">
                            <DetailsHeading title="Exchange:" /><br />
                            {{ tx.exchange == "" ? "N/A" : tx.exchange }}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-6">
                            <DetailsHeading title="Fee:" /><br />
                            {{ tx.fee }} {{ tx.quoteCurrencySymbol }}
                        </div>
                        <div class="col-6 text-end">
                            <DetailsHeading title="Unit Price:" /><br />
                            {{ tx.unitPrice }} {{ tx.quoteCurrencySymbol }}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <DetailsHeading title="Notes:" /> <br />
                            {{ tx.notes == "" ? "N/A" : tx.notes }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div v-else>
            Loading Transactions...
        </div>
    </div>
</template>

